Index: trunk/ddt/make-package-debian
===================================================================
--- trunk/ddt/make-package-debian	(revision 252)
+++ trunk/ddt/make-package-debian	(revision 253)
@@ -11,7 +11,8 @@
 [ -n "${tmp_folder}" -a -d "${tmp_folder}" ] || exit 1
 
-# Set Version
-DDT_VERSION=$(grep 'version->declare' ddt | cut -f 2 -d "'") #'
-LOCAL_VERSION=5
+# Set Name and Version
+PKG_NAME=ddt
+CODE_VERSION=$(grep 'version->declare' ddt | cut -f 2 -d "'") #'
+PKG_VERSION=6
 
 # Create future tree
@@ -27,13 +28,16 @@
 (cd ${tmp_folder}/usr/bin;            ln -s ddt      dhcp-dns-tools)
 (cd ${tmp_folder}/usr/share/man/man1; ln -s ddt.1.gz dhcp-dns-tools.1.gz)
+chmod -R a+rx        ${tmp_folder}/usr/bin/ddt
+chmod -R a+rX,go-w   ${tmp_folder}/usr
+chmod -R a+rX,go-w   ${tmp_folder}/etc
 
 # Data archive
 rm -f ${tmp_folder}/data.tar.gz
-(cd ${tmp_folder}; tar czf data.tar.gz ./usr ./etc)
+(cd ${tmp_folder}; tar --owner root --group root -czf data.tar.gz ./usr ./etc)
 
 # Control file
 cat <<END > ${tmp_folder}/control
-Package: ddt
-Version: ${DDT_VERSION}-${LOCAL_VERSION}
+Package: ${PKG_NAME}
+Version: ${CODE_VERSION}-${PKG_VERSION}
 Section: utils
 Tag: implemented-in::perl, interface::commandline, role::program
@@ -61,5 +65,5 @@
 # Control archive
 rm -f ${tmp_folder}/control.tar.gz
-(cd ${tmp_folder}; tar czf control.tar.gz control)
+(cd ${tmp_folder}; tar --owner root --group root -czf control.tar.gz control)
 
 # Format deb package
@@ -67,5 +71,5 @@
 
 # Create package (control before data)
-ar -r ddt_${DDT_VERSION}-${LOCAL_VERSION}_all.deb ${tmp_folder}/debian-binary ${tmp_folder}/control.tar.gz ${tmp_folder}/data.tar.gz
+ar -r ${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb ${tmp_folder}/debian-binary ${tmp_folder}/control.tar.gz ${tmp_folder}/data.tar.gz
       
 # Clean
@@ -74,6 +78,6 @@
 # Prepare reprepro upload
 echo "# Prepare reprepro upload"
-echo "( cd /srv/www/debian/ ; reprepro includedeb wheezy   ~/wheezy/ddt_${DDT_VERSION}-${LOCAL_VERSION}_all.deb )"
-echo "( cd /srv/www/debian/ ; reprepro includedeb jessie   ~/jessie/ddt_${DDT_VERSION}-${LOCAL_VERSION}_all.deb )"
-echo "( cd /srv/www/debian/ ; reprepro includedeb stretch ~/stretch/ddt_${DDT_VERSION}-${LOCAL_VERSION}_all.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb wheezy   ~/wheezy/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb jessie   ~/jessie/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb stretch ~/stretch/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb )"
 echo "( cd /srv/www/debian/ ; reprepro dumpreferences ) | grep -i ddt"
Index: trunk/nagios-velvice/make-package-debian
===================================================================
--- trunk/nagios-velvice/make-package-debian	(revision 252)
+++ trunk/nagios-velvice/make-package-debian	(revision 253)
@@ -11,7 +11,8 @@
 [ -n "${tmp_folder}" -a -d "${tmp_folder}" ] || exit 1
 
-# Set Version
-VELVICE_VERSION=$(grep 'version->declare' velvice.cgi | cut -f 2 -d "'") #'
-LOCAL_VERSION=3
+# Set Name and Version
+PKG_NAME=nagios3-velvice
+CODE_VERSION=$(grep 'version->declare' velvice.cgi | cut -f 2 -d "'") #'
+PKG_VERSION=3
 
 # Create future tree
@@ -34,6 +35,6 @@
 # Control file
 cat <<END > ${tmp_folder}/control
-Package: nagios3-velvice
-Version: ${VELVICE_VERSION}-${LOCAL_VERSION}
+Package: ${PKG_NAME}
+Version: ${CODE_VERSION}-${PKG_VERSION}
 Section: utils
 Tag: implemented-in::perl, interface::commandline, role::program
@@ -57,5 +58,5 @@
 
 # Create package (control before data)
-ar -r nagios3-velvice_${VELVICE_VERSION}-${LOCAL_VERSION}_all.deb ${tmp_folder}/debian-binary ${tmp_folder}/control.tar.gz ${tmp_folder}/data.tar.gz
+ar -r ${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb ${tmp_folder}/debian-binary ${tmp_folder}/control.tar.gz ${tmp_folder}/data.tar.gz
       
 # Clean
@@ -64,6 +65,6 @@
 # Prepare reprepro upload
 echo "# Prepare reprepro upload"
-echo "( cd /srv/www/debian/ ; reprepro includedeb wheezy   ~/wheezy/nagios3-velvice_${VELVICE_VERSION}-${LOCAL_VERSION}_all.deb )"
-echo "( cd /srv/www/debian/ ; reprepro includedeb jessie   ~/jessie/nagios3-velvice_${VELVICE_VERSION}-${LOCAL_VERSION}_all.deb )"
-echo "( cd /srv/www/debian/ ; reprepro includedeb stretch ~/stretch/nagios3-velvice_${VELVICE_VERSION}-${LOCAL_VERSION}_all.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb wheezy   ~/wheezy/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb jessie   ~/jessie/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb stretch ~/stretch/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_all.deb )"
 echo "( cd /srv/www/debian/ ; reprepro dumpreferences ) | grep -i nagios3-velvice"
Index: trunk/project-meta/make-package-debian
===================================================================
--- trunk/project-meta/make-package-debian	(revision 252)
+++ trunk/project-meta/make-package-debian	(revision 253)
@@ -11,7 +11,8 @@
 [ -n "${tmp_folder}" -a -d "${tmp_folder}" ] || exit 1
 
-# Set Version
-PROJECT_META_VERSION=$(grep 'version->declare' project-meta | cut -f 2 -d "'")
-LOCAL_VERSION=1
+# Set Name and Version
+PKG_NAME=project-meta
+CODE_VERSION=$(grep 'version->declare' project-meta | cut -f 2 -d "'") #'
+PKG_VERSION=2
 
 # Create future tree
@@ -28,13 +29,16 @@
 cp template.d/*.tt               ${tmp_folder}/usr/share/project-meta/template.d/
 cp project-meta.bash_completion  ${tmp_folder}/etc/bash_completion.d/
+chmod -R a+rx        ${tmp_folder}/usr/bin/project-meta
+chmod -R a+rX,go-w   ${tmp_folder}/usr
+chmod -R a+rX,go-w   ${tmp_folder}/etc
 
 # Data archive
 rm -f ${tmp_folder}/data.tar.gz
-(cd ${tmp_folder}; tar czf data.tar.gz ./usr ./etc)
+(cd ${tmp_folder}; tar --owner root --group root -czf data.tar.gz ./usr ./etc)
 
 # Control file
 cat <<END > ${tmp_folder}/control
-Package: project-meta
-Version: ${PROJECT_META_VERSION}-${LOCAL_VERSION}
+Package: ${PKG_NAME}
+Version: ${CODE_VERSION}-${PKG_VERSION}
 Section: utils
 Tag: implemented-in::perl, interface::commandline, role::program,
@@ -55,5 +59,5 @@
 # Control archive
 rm -f ${tmp_folder}/control.tar.gz
-(cd ${tmp_folder}; tar czf control.tar.gz control)
+(cd ${tmp_folder}; tar --owner root --group root -czf control.tar.gz control)
 
 # Format deb package
@@ -61,5 +65,5 @@
 
 # Create package (control before data)
-ar -r project-meta_${PROJECT_META_VERSION}-${LOCAL_VERSION}_amd64.deb ${tmp_folder}/debian-binary ${tmp_folder}/control.tar.gz ${tmp_folder}/data.tar.gz
+ar -r ${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_amd64.deb ${tmp_folder}/debian-binary ${tmp_folder}/control.tar.gz ${tmp_folder}/data.tar.gz
       
 # Clean
@@ -68,4 +72,4 @@
 # Prepare reprepro upload
 echo "# Prepare reprepro upload"
-echo "( cd /srv/www/debian/ ; reprepro includedeb jessie ~/jessie/project-meta_${PROJECT_META_VERSION}-${LOCAL_VERSION}_amd64.deb )"
+echo "( cd /srv/www/debian/ ; reprepro includedeb jessie ~/jessie/${PKG_NAME}_${CODE_VERSION}-${PKG_VERSION}_amd64.deb )"
 echo "( cd /srv/www/debian/ ; reprepro dumpreferences ) | grep -i project-meta"